.\" Copyright (C) 2010 Geoff Johnstone.
.\" See section COPYING for conditions for redistribution.
.TH usmb 1 "April 2010" "usmb" "User Commands"
.fp 0 CR
.SH NAME
usmb \- Mount SMB/CIFS shares via FUSE
.SH SYNOPSIS
usmb [\-c \fIfile\fR] [\-d] [\-f] \fImount_id\fR
.br
usmb [\-c \fIfile\fR] \-u \fImount_id\fR
.SH DESCRIPTION
.P
usmb mounts SMB and CIFS shares through FUSE, including Samba shares and
Windows shared folders. Unlike some other such filesystems, usmb can mount
shares from any server, including those not browsable or advertised on the
network.
.P
Shares, usernames and other details are defined in a configuration file, by
default ${HOME}/.usmb.conf.
.SH OPTIONS
.TP
\fB\-c\fR \fIfile\fR, \fB\-\-config\fR=\fIfile\fR
Use \fIfile\fR rather than ${HOME}/.usmb.conf as the configuration file.
.TP
\fB\-d\fR, \fB\-\-debug\fR
Debug mode.
.TP
\fB\-f\fR, \fB\-\-nofork\fR
Foreground operation (i.e. don't daemonise).
.TP
\fB\-h\fR, \fB\-\-help\fR
Show usage information and exit.
.TP
\fB\-u\fR, \fB\-\-unmount\fR
Unmount the given filesystem.
.TP
\fB\-v\fR, \fB\-\-version\fR
Show usmb, FUSE and Samba versions and exit.
.P
.SH CONFIGURATION
.P
usmb uses the configuration file ${HOME}/.usmb.conf to define shares and the
credentials used to access them. The configuration file is an XML file with
two main elements: credentials and mounts. The file can contain any number of
credentials and mounts elements; the whole file is wrapped in a usmbconfig
element.
.SS Credentials
.P
.ft CR
  <credentials id="\fIID used in mount elements\f(CR">
    <domain>\fIdomain or workgroup\f(CR</domain>
    <username>\fIusername\f(CR</username>
    <password>\fIpassword (optional)\f(CR</password>
  </credentials>
.P
Each credentials element defines a domain/username/password triple. If you
omit the <password> element then usmb will prompt for a password when the
credentials are used.
.SS Mounts
.P
.ft CR
  <mount id="\fImount_id\f(CR" credentials="\fIID of credentials to use\f(CR">
    <server>\fIhostname or IP address of server\f(CR</server>
    <share>\fIshare name\f(CR</share>
    <mountpoint>\fI/path/to/mount/point\f(CR</mountpoint>
    <options>\fImount options\f(CR</options>
  </mount>
.P
A mount element describes a share. The id attribute is given on the usmb
command line to identify the share to mount. The credentials attribute
identified the id of the credentials element to use. The (optional) options
element gives a comma-separated list of FUSE mount options:
.TP
\fBhard_remove\fR
Immediate removal (don't hide files)
.TP
\fBumask=M\fR
Set file permissions (octal)
.TP
\fBuid=N\fR
Set file owner
.TP
\fBgid=N\fR
Set file group
.TP
\fBallow_other\fR
Allow access to other users
.TP
\fBallow_root\fR
Allow access to root
.TP
\fBnonempty\fR
Allow mount over non-empty directory
.SS Example
.P
.ft CR
<?xml version="1.0" encoding="ISO-8859-1"?>
.br
<usmbconfig>

  <credentials id="cred1">
    <domain>WORKGROUP</domain>
    <username>user</username>
    <password>pass</password>
  </credentials>

  <credentials id="cred2">
    <domain>mydomain</domain>
    <username>anotheruser</username>
    <!--  No password element => prompt for password at runtime. -->
  </credentials>

  <mount id="home" credentials="cred1">
    <server>192.168.0.5</server>
    <share>myshare</share>
    <mountpoint>/tmp/smb</mountpoint>
  </mount>

  <mount id="music" credentials="cred2">
    <server>winbox</server>
    <share>music</share>

    <!-- You can use ~/xyz or ~user/xyz for the mountpoint. -->
    <mountpoint>~/music</mountpoint>
    <options>allow_root</options>
  </mount>

</usmbconfig>
.P
This defines two shares:
.RS 2
\\\\192.168.0.5\\myshare on /tmp/smb authenticating as WORKGROUP\\user
.br
\\\\winbox\\music on ${HOME}/music authenticating as mydomain\\anotheruser
.RE
.P
These can be mounted using "usmb home" or "usmb music".
.SH AUTHOR
Geoff Johnstone, with contributions from Jonathan Schultz, Stijn Hoop, Nigel
Smith and Michal Suchanek.
.SH FILES
${HOME}/.usmb.conf
.SH BUGS
.P
usmb should not require a configuration file. The configuration file can
provide defaults but you should be able to specify everything necessary on
the command line.
.P
usmb does not support Kerberos / GSSAPI authentication, although a development
branch exists with preliminary support.
.SH "SEE ALSO"
fusermount(1), mount.cifs(8), umount.cifs(8).
.SH COPYING
Copyright \(co 2006-2013 Geoff Johnstone.
.br
Licence: GNU GPL version 3 <http://gnu.org/licenses/gpl.html>.
